//
//  ZJAppInstance.h
//  HDMall
//
//  Created by Javen on 2017/7/27.
//  Copyright © 2017年 上海勾芒信息科技. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "UserInfo.h"
#import "ZJPermissionManager.h"
#define AppGlobal [ZJAppInstance shareInstance]

/**
 app全局信息
 */
@interface ZJAppInstance : NSObject

#pragma mark - 本地保存的信息
/** 保存下来的用户名 */
@property (strong, nonatomic) NSString *savedName;
/** 保存下来的密码 */
@property (strong, nonatomic) NSString *savedPWD;
/** 是否商场登录 */
@property (assign, nonatomic) BOOL isMall;

#pragma mark - 网络获取的相关信息
@property (strong ,nonatomic) UserInfo *user;
/** 权限 */
@property (strong, nonatomic) ZJPermissionManager *permission;

+ (ZJAppInstance *)shareInstance;


/** 获取用户的所有合同uuid */
- (NSMutableArray *)getUserContractUuids;

/** 获取商户用户的合同（默认是第一个，异常状况会提示 */
- (UserInfo_contracts *)getTenantContract;

/** 保存基础信息 */
- (void)saveBaseInfo;

@end
